## libtins 4.0

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.1)
PROJECT(libtins)

OPTION(LIBTINS_BUILD_EXAMPLES "Build examples" ON)
OPTION(LIBTINS_BUILD_TESTS "Build tests" ON)

# Compile in release mode by default
IF(NOT CMAKE_BUILD_TYPE)
    MESSAGE(STATUS "Setting build type to 'RelWithDebInfo' as none was specified.")
    SET(CMAKE_BUILD_TYPE RelWithDebInfo)
ELSE(NOT CMAKE_BUILD_TYPE)
    MESSAGE(STATUS "Using specified '${CMAKE_BUILD_TYPE}' build type.")
ENDIF(NOT CMAKE_BUILD_TYPE)

# Compilation flags.
IF(MSVC)
    # Don't always use Wall, since VC's /Wall is ridiculously verbose.
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3")
    # Disable VC secure checks, since these are not really issues.
    ADD_DEFINITIONS("-D_CRT_SECURE_NO_WARNINGS=1")
    ADD_DEFINITIONS("-D_SCL_SECURE_NO_WARNINGS=1")
    ADD_DEFINITIONS("-DNOGDI=1")
ELSE()
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
ENDIF()

IF(APPLE)
    # This is set to ON as of policy CMP0042
    SET(CMAKE_MACOSX_RPATH ON)
ENDIF()

# Build output checks
OPTION(LIBTINS_BUILD_SHARED "Build libtins as a shared library." ON)
IF(LIBTINS_BUILD_SHARED)
    MESSAGE(
        STATUS
        "Build will generate a shared library. "
        "Use LIBTINS_BUILD_SHARED=0 to perform a static build"
    )
    SET(LIBTINS_TYPE SHARED)
ELSE(LIBTINS_BUILD_SHARED)
    MESSAGE(STATUS "Build will generate a static library.")
    SET(LIBTINS_TYPE STATIC)
    ADD_DEFINITIONS("-DTINS_STATIC=1")
ENDIF(LIBTINS_BUILD_SHARED)

# The version number.
SET(LIBTINS_VERSION_MAJOR 4)
SET(LIBTINS_VERSION_MINOR 0)
SET(LIBTINS_VERSION "${LIBTINS_VERSION_MAJOR}.${LIBTINS_VERSION_MINOR}")

# Required Packages
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules/")

# Allow disabling packet capture mechanism
OPTION(LIBTINS_ENABLE_PCAP "Enable capturing packets via libpcap" ON)

# Look for libpcap
IF(LIBTINS_ENABLE_PCAP)
    FIND_PACKAGE(PCAP REQUIRED)
    SET(TINS_HAVE_PCAP ON)
ENDIF()

# Set some Windows specific flags
IF(WIN32)
    # We need to link against these libs
    SET(LIBTINS_OS_LIBS Ws2_32.lib Iphlpapi.lib)

    # Add the NOMINMAX macro to avoid Windows' min and max macros.
    ADD_DEFINITIONS(-DNOMINMAX)

    # MinWG need some extra definitions to compile properly (WIN32 for PCAP and WIN32_WINNT version for ws2tcpip.h)
    IF(MINGW)
        ADD_DEFINITIONS(-DWIN32)
        MACRO(get_WIN32_WINNT version)
        IF (WIN32 AND CMAKE_SYSTEM_VERSION)
            SET(ver ${CMAKE_SYSTEM_VERSION})
            STRING(REPLACE "." "" ver ${ver})
            STRING(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})
            SET(${version} "0x${ver}")
        ENDIF()
        ENDMACRO()
        get_WIN32_WINNT(ver)
        ADD_DEFINITIONS(-D_WIN32_WINNT=${ver})
    ENDIF(MINGW)

ENDIF(WIN32)

INCLUDE(ExternalProject)

# *******************
# Compilation options
# *******************

# Always check for C++ features
INCLUDE(CheckCXXFeatures)

IF(HAS_GCC_BUILTIN_SWAP)
    SET(TINS_HAVE_GCC_BUILTIN_SWAP ON)
ENDIF()

# C++11 support
OPTION(LIBTINS_ENABLE_CXX11 "Compile libtins with c++11 features" ON)
IF(LIBTINS_ENABLE_CXX11)
    # We only use declval and decltype on gcc/clang as VC fails to build that code,
    # at least on VC2013
    IF(HAS_CXX11_RVALUE_REFERENCES AND HAS_CXX11_FUNCTIONAL AND HAS_CXX11_CHRONO AND
       HAS_CXX11_NOEXCEPT AND ((HAS_CXX11_DECLVAL AND HAS_CXX11_DECLTYPE) OR MSVC))
        SET(TINS_HAVE_CXX11 ON)
        MESSAGE(STATUS "Enabling C++11 features")
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_COMPILER_FLAGS}")
    ELSE()
        MESSAGE(WARNING "The compiler doesn't support the necessary C++11 features. "
                        "Disabling C++11 on this build")
    ENDIF()
ELSE(LIBTINS_ENABLE_CXX11)
    MESSAGE(
        WARNING
        "Disabling C++11 features. Use LIBTINS_ENABLE_CXX11=1 to enable them. "
        "Unless you are using an old compiler, you should enable this option, "
        "as it increases the library's performance")
ENDIF(LIBTINS_ENABLE_CXX11)

# IEEE 802.11 and WPA2 decryption support
OPTION(LIBTINS_ENABLE_DOT11 "Compile libtins with IEEE 802.11 support" ON)
OPTION(LIBTINS_ENABLE_WPA2 "Compile libtins with WPA2 decryption features (requires OpenSSL)" ON)
IF(LIBTINS_ENABLE_DOT11)
    SET(TINS_HAVE_DOT11 ON)
    MESSAGE(STATUS "Enabling IEEE 802.11 support.")
    IF(LIBTINS_ENABLE_WPA2)
        FIND_PACKAGE(OpenSSL)
        IF(OPENSSL_FOUND)
            SET(TINS_HAVE_WPA2_DECRYPTION ON)
            MESSAGE(STATUS "Enabling WPA2 decryption support.")
        ELSE()
            MESSAGE(WARNING "Disabling WPA2 decryption support since OpenSSL was not found")
            # Default this to empty strings
            SET(OPENSSL_INCLUDE_DIR "")
            SET(OPENSSL_LIBRARIES "")
        ENDIF()
    ELSE(LIBTINS_ENABLE_WPA2)
        MESSAGE(STATUS "Disabling WPA2 decryption support.")
    ENDIF(LIBTINS_ENABLE_WPA2)
ENDIF(LIBTINS_ENABLE_DOT11)

# Optionally enable TCPIP classes (on by default)
OPTION(LIBTINS_ENABLE_TCPIP "Enable TCPIP classes" ON)
IF(LIBTINS_ENABLE_TCPIP AND TINS_HAVE_CXX11)
    SET(TINS_HAVE_TCPIP ON)
    MESSAGE(STATUS "Enabling TCPIP classes")
ELSE()
    SET(TINS_HAVE_TCPIP OFF)
    MESSAGE(STATUS "Disabling TCPIP classes")
ENDIF()

# Search for libboost
FIND_PACKAGE(Boost)

# Optionally enable the ACK tracker (on by default)
OPTION(LIBTINS_ENABLE_ACK_TRACKER "Enable TCP ACK tracking support" ON)
IF(LIBTINS_ENABLE_ACK_TRACKER AND TINS_HAVE_CXX11)
    IF (Boost_FOUND)
        MESSAGE(STATUS "Enabling TCP ACK tracking support.")
        INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
        SET(TINS_HAVE_ACK_TRACKER ON)
    ELSE()
        MESSAGE(WARNING "Disabling ACK tracking support as boost.icl was not found")
        SET(TINS_HAVE_ACK_TRACKER OFF)
    ENDIF()
ELSE()
    SET(TINS_HAVE_ACK_TRACKER OFF)
    MESSAGE(STATUS "Disabling ACK tracking support")
ENDIF()

# Optionally enable the TCP stream custom data (on by default)
OPTION(LIBTINS_ENABLE_TCP_STREAM_CUSTOM_DATA "Enable TCP stream custom data support" ON)
IF(LIBTINS_ENABLE_TCP_STREAM_CUSTOM_DATA AND TINS_HAVE_CXX11)
    IF (Boost_FOUND)
        MESSAGE(STATUS "Enabling TCP stream custom data support.")
        INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
        SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA ON)
    ELSE()
        MESSAGE(WARNING "Disabling TCP stream custom data support as boost.any was not found")
        SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA OFF)
    ENDIF()
ELSE()
    SET(TINS_HAVE_TCP_STREAM_CUSTOM_DATA OFF)
    MESSAGE(STATUS "Disabling TCP stream custom data support")
ENDIF()

OPTION(LIBTINS_ENABLE_WPA2_CALLBACKS "Enable WPA2 callback interface" ON)
IF(LIBTINS_ENABLE_WPA2_CALLBACKS AND TINS_HAVE_WPA2_DECRYPTION AND TINS_HAVE_CXX11)
    SET(STATUS "Enabling WPA2 callback interface")
    SET(TINS_HAVE_WPA2_CALLBACKS ON)
ENDIF()

# Use pcap_sendpacket to send l2 packets rather than raw sockets
IF(WIN32)
    SET(USE_PCAP_SENDPACKET_DEFAULT ON)
ELSE(WIN32)
    SET(USE_PCAP_SENDPACKET_DEFAULT OFF)
ENDIF(WIN32)

OPTION(LIBTINS_USE_PCAP_SENDPACKET "Use pcap_sendpacket to send l2 packets"
        ${USE_PCAP_SENDPACKET_DEFAULT})
IF(LIBTINS_ENABLE_PCAP AND LIBTINS_USE_PCAP_SENDPACKET)
    SET(TINS_HAVE_PACKET_SENDER_PCAP_SENDPACKET ON)
    MESSAGE(STATUS "Using pcap_sendpacket to send l2 packets.")
ENDIF()

# Add a target to generate API documentation using Doxygen
FIND_PACKAGE(Doxygen QUIET)
IF(DOXYGEN_FOUND)
    CONFIGURE_FILE(
        ${CMAKE_CURRENT_SOURCE_DIR}/docs/Doxyfile.in
        ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        @ONLY
    )
    ADD_CUSTOM_TARGET(
        docs
        ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen" VERBATIM
    )
ENDIF(DOXYGEN_FOUND)

# The library output directory
SET(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
SET(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

# Configuration file
CONFIGURE_FILE(
  "${PROJECT_SOURCE_DIR}/include/tins/config.h.in"
  "${PROJECT_SOURCE_DIR}/include/tins/config.h"
)

# Support for pkg-config
SET(CMAKE_INSTALL_LIBDIR lib)
SET(pkgconfig_prefix      ${CMAKE_INSTALL_PREFIX})
SET(pkgconfig_exec_prefix ${CMAKE_INSTALL_PREFIX})
SET(pkgconfig_libdir      ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
SET(pkgconfig_version     ${LIBTINS_VERSION})
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libtins.pc.in
                ${CMAKE_CURRENT_BINARY_DIR}/libtins.pc @ONLY)

INSTALL(
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/libtins.pc
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

# Confiugure the uninstall script
CONFIGURE_FILE(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)

# Add uninstall target
ADD_CUSTOM_TARGET(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

# ******************
# Add subdirectories
# ******************
ADD_SUBDIRECTORY(src)

IF(LIBTINS_BUILD_EXAMPLES)
    IF(LIBTINS_ENABLE_PCAP)
        ADD_SUBDIRECTORY(examples)
    ELSE()
        MESSAGE(STATUS "Not building examples as pcap support is disabled")
    ENDIF()
ENDIF()

IF(LIBTINS_BUILD_TESTS)
    # Only include googletest if the git submodule has been fetched
    IF(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/googletest/CMakeLists.txt")
        # Enable tests and add the test directory
        MESSAGE(STATUS "Tests have been enabled")
        SET(GOOGLETEST_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/googletest)
        SET(GOOGLETEST_INCLUDE ${GOOGLETEST_ROOT}/googletest/include)
        SET(GOOGLETEST_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/googletest)
        SET(GOOGLETEST_LIBRARY ${GOOGLETEST_BINARY_DIR}/googletest)

        ExternalProject_Add(
            googletest
            DOWNLOAD_COMMAND ""
            SOURCE_DIR ${GOOGLETEST_ROOT}
            BINARY_DIR ${GOOGLETEST_BINARY_DIR}
            CMAKE_CACHE_ARGS "-DBUILD_GTEST:bool=ON" "-DBUILD_GMOCK:bool=OFF"
                            "-Dgtest_force_shared_crt:bool=ON"
                            "-DCMAKE_CXX_COMPILER:path=${CMAKE_CXX_COMPILER}"
            INSTALL_COMMAND ""
        )
        # Make sure we build googletest before anything else
        ADD_DEPENDENCIES(tins googletest)
        ENABLE_TESTING()
        ADD_SUBDIRECTORY(tests)
    ELSE()
        MESSAGE(STATUS "googletest git submodule is absent. Run `git submodule init && git submodule update` to get it")
    ENDIF()
ENDIF()

# **********************************
# CMake project configuration export
# **********************************

# Add all targets to the build-tree export set
EXPORT(
    TARGETS tins
    FILE "${PROJECT_BINARY_DIR}/libtinsTargets.cmake"
)

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
EXPORT(PACKAGE libtins)

# Create the libtinsConfig.cmake and libtinsConfigVersion.cmake files
# for the build tree
SET(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/include")
CONFIGURE_FILE(
    cmake/libtinsConfig.cmake.in
    "${PROJECT_BINARY_DIR}/libtinsConfig.cmake" @ONLY
)
CONFIGURE_FILE(
    cmake/libtinsConfigVersion.cmake.in
    "${PROJECT_BINARY_DIR}/libtinsConfigVersion.cmake" @ONLY
)
# Install the libtinsConfig.cmake and libtinsConfigVersion.cmake
INSTALL(
    FILES
    "${PROJECT_BINARY_DIR}/libtinsConfig.cmake"
    "${PROJECT_BINARY_DIR}/libtinsConfigVersion.cmake"
    DESTINATION CMake
    COMPONENT dev
)

# Install the export set for use with the install-tree
INSTALL(
    EXPORT libtinsTargets
    DESTINATION CMake
    COMPONENT dev
)

=== src/CMakeLists.txt ===
SET(LIBTINS_INCLUDE_DIR ../include/)

IF(HAVE_PCAP_IMMEDIATE_MODE)
    ADD_DEFINITIONS("-DHAVE_PCAP_IMMEDIATE_MODE=1")
ENDIF()

IF(HAVE_PCAP_TIMESTAMP_PRECISION)
    ADD_DEFINITIONS("-DHAVE_PCAP_TIMESTAMP_PRECISION=1")
ENDIF()

INCLUDE_DIRECTORIES(
    ${LIBTINS_INCLUDE_DIR}
    ${OPENSSL_INCLUDE_DIR}
    ${PCAP_INCLUDE_DIR}
)

set(SOURCES
    address_range.cpp
    arp.cpp
    bootp.cpp
    crypto.cpp
    detail/address_helpers.cpp
    detail/icmp_extension_helpers.cpp
    detail/pdu_helpers.cpp
    detail/sequence_number_helpers.cpp
    dhcp.cpp
    dhcpv6.cpp
    dns.cpp
    dot3.cpp
    dot1q.cpp
    eapol.cpp
    ethernetII.cpp
    handshake_capturer.cpp
    hw_address.cpp
    icmp_extension.cpp
    icmp.cpp
    icmpv6.cpp
    ip_reassembler.cpp
    ip.cpp
    ip_address.cpp
    ipv6.cpp
    ipv6_address.cpp
    ipsec.cpp
    llc.cpp
    loopback.cpp
    mpls.cpp
    memory_helpers.cpp
    network_interface.cpp
    packet_sender.cpp
    pdu.cpp
    pdu_iterator.cpp
    pdu_option.cpp
    pppoe.cpp
    radiotap.cpp
    rawpdu.cpp
    rsn_information.cpp
    sll.cpp
    snap.cpp
    stp.cpp
    tcp.cpp
    tcp_ip/ack_tracker.cpp
    tcp_ip/flow.cpp
    tcp_ip/data_tracker.cpp
    tcp_ip/stream.cpp
    tcp_ip/stream_follower.cpp
    tcp_ip/stream_identifier.cpp
    timestamp.cpp
    udp.cpp
    utils/checksum_utils.cpp
    utils/frequency_utils.cpp
    utils/radiotap_parser.cpp
    utils/radiotap_writer.cpp
    utils/routing_utils.cpp
    utils/resolve_utils.cpp
    utils/pdu_utils.cpp
)

set(HEADERS
    ${LIBTINS_INCLUDE_DIR}/tins/address_range.h
    ${LIBTINS_INCLUDE_DIR}/tins/arp.h
    ${LIBTINS_INCLUDE_DIR}/tins/bootp.h
    ${LIBTINS_INCLUDE_DIR}/tins/handshake_capturer.h
    ${LIBTINS_INCLUDE_DIR}/tins/stp.h
    ${LIBTINS_INCLUDE_DIR}/tins/pppoe.h
    ${LIBTINS_INCLUDE_DIR}/tins/config.h
    ${LIBTINS_INCLUDE_DIR}/tins/constants.h
    ${LIBTINS_INCLUDE_DIR}/tins/crypto.h
    ${LIBTINS_INCLUDE_DIR}/tins/cxxstd.h
    ${LIBTINS_INCLUDE_DIR}/tins/data_link_type.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/address_helpers.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/icmp_extension_helpers.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/pdu_helpers.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/sequence_number_helpers.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/smart_ptr.h
    ${LIBTINS_INCLUDE_DIR}/tins/detail/type_traits.h
    ${LIBTINS_INCLUDE_DIR}/tins/dhcp.h
    ${LIBTINS_INCLUDE_DIR}/tins/dhcpv6.h
    ${LIBTINS_INCLUDE_DIR}/tins/dns.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot3.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot1q.h
    ${LIBTINS_INCLUDE_DIR}/tins/eapol.h
    ${LIBTINS_INCLUDE_DIR}/tins/endianness.h
    ${LIBTINS_INCLUDE_DIR}/tins/ethernetII.h
    ${LIBTINS_INCLUDE_DIR}/tins/exceptions.h
    ${LIBTINS_INCLUDE_DIR}/tins/hw_address.h
    ${LIBTINS_INCLUDE_DIR}/tins/icmp_extension.h
    ${LIBTINS_INCLUDE_DIR}/tins/icmp.h
    ${LIBTINS_INCLUDE_DIR}/tins/icmpv6.h
    ${LIBTINS_INCLUDE_DIR}/tins/ieee802_3.h
    ${LIBTINS_INCLUDE_DIR}/tins/internals.h
    ${LIBTINS_INCLUDE_DIR}/tins/ip_reassembler.h
    ${LIBTINS_INCLUDE_DIR}/tins/ip.h
    ${LIBTINS_INCLUDE_DIR}/tins/ip_address.h
    ${LIBTINS_INCLUDE_DIR}/tins/ipv6.h
    ${LIBTINS_INCLUDE_DIR}/tins/ipv6_address.h
    ${LIBTINS_INCLUDE_DIR}/tins/ipsec.h
    ${LIBTINS_INCLUDE_DIR}/tins/llc.h
    ${LIBTINS_INCLUDE_DIR}/tins/loopback.h
    ${LIBTINS_INCLUDE_DIR}/tins/macros.h
    ${LIBTINS_INCLUDE_DIR}/tins/mpls.h
    ${LIBTINS_INCLUDE_DIR}/tins/memory_helpers.h
    ${LIBTINS_INCLUDE_DIR}/tins/network_interface.h
    ${LIBTINS_INCLUDE_DIR}/tins/packet.h
    ${LIBTINS_INCLUDE_DIR}/tins/packet_sender.h
    ${LIBTINS_INCLUDE_DIR}/tins/pdu.h
    ${LIBTINS_INCLUDE_DIR}/tins/pdu_allocator.h
    ${LIBTINS_INCLUDE_DIR}/tins/pdu_cacher.h
    ${LIBTINS_INCLUDE_DIR}/tins/pdu_iterator.h
    ${LIBTINS_INCLUDE_DIR}/tins/pdu_option.h
    ${LIBTINS_INCLUDE_DIR}/tins/radiotap.h
    ${LIBTINS_INCLUDE_DIR}/tins/rawpdu.h
    ${LIBTINS_INCLUDE_DIR}/tins/rsn_information.h
    ${LIBTINS_INCLUDE_DIR}/tins/sll.h
    ${LIBTINS_INCLUDE_DIR}/tins/small_uint.h
    ${LIBTINS_INCLUDE_DIR}/tins/snap.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/ack_tracker.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/flow.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/data_tracker.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/stream.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/stream_follower.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_ip/stream_identifier.h
    ${LIBTINS_INCLUDE_DIR}/tins/timestamp.h
    ${LIBTINS_INCLUDE_DIR}/tins/tins.h
    ${LIBTINS_INCLUDE_DIR}/tins/udp.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/checksum_utils.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/frequency_utils.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/radiotap_parser.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/radiotap_writer.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/routing_utils.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/resolve_utils.h
    ${LIBTINS_INCLUDE_DIR}/tins/utils/pdu_utils.h
)

SET(DOT11_DEPENDENT_SOURCES
    dot11/dot11_base.cpp
    dot11/dot11_data.cpp
    dot11/dot11_mgmt.cpp
    dot11/dot11_beacon.cpp
    dot11/dot11_assoc.cpp
    dot11/dot11_auth.cpp
    dot11/dot11_probe.cpp
    dot11/dot11_control.cpp
)

SET(DOT11_DEPENDENT_HEADERS
    ${LIBTINS_INCLUDE_DIR}/tins/dot11.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_base.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_data.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_mgmt.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_beacon.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_assoc.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_auth.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_probe.h
    ${LIBTINS_INCLUDE_DIR}/tins/dot11/dot11_control.h
)

IF(LIBTINS_ENABLE_DOT11)
    SET(SOURCES ${SOURCES} ${DOT11_DEPENDENT_SOURCES})
    SET(HEADERS ${HEADERS} ${DOT11_DEPENDENT_HEADERS})
ENDIF()

SET(PCAP_DEPENDENT_SOURCES
    sniffer.cpp
    packet_writer.cpp
    pktap.cpp
    tcp_stream.cpp
    offline_packet_filter.cpp
    ppi.cpp
)

SET(PCAP_DEPENDENT_HEADERS
    ${LIBTINS_INCLUDE_DIR}/tins/offline_packet_filter.h
    ${LIBTINS_INCLUDE_DIR}/tins/packet_writer.h
    ${LIBTINS_INCLUDE_DIR}/tins/pktap.h
    ${LIBTINS_INCLUDE_DIR}/tins/ppi.h
    ${LIBTINS_INCLUDE_DIR}/tins/sniffer.h
    ${LIBTINS_INCLUDE_DIR}/tins/tcp_stream.h
)

IF(LIBTINS_ENABLE_PCAP)
    SET(SOURCES ${SOURCES} ${PCAP_DEPENDENT_SOURCES})
    SET(HEADERS ${HEADERS} ${PCAP_DEPENDENT_HEADERS})
ENDIF() 

ADD_LIBRARY( 
    tins ${LIBTINS_TYPE}
    ${SOURCES}
    ${HEADERS}
)

TARGET_LINK_LIBRARIES(tins ${PCAP_LIBRARY} ${OPENSSL_LIBRARIES} ${LIBTINS_OS_LIBS})

SET_TARGET_PROPERTIES(tins PROPERTIES OUTPUT_NAME tins)
SET_TARGET_PROPERTIES(tins PROPERTIES VERSION ${LIBTINS_VERSION} SOVERSION ${LIBTINS_VERSION} )

# Install instructions for this target
INSTALL( 
    TARGETS tins
    EXPORT libtinsTargets
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib
    COMPONENT dev
)

MACRO(INSTALL_HEADERS_WITH_DIRECTORY HEADER_LIST)
    FOREACH(HEADER ${HEADERS})
        # Extract directory name and remove leading '../'
        get_filename_component(DIR ${HEADER} PATH)
        STRING(REGEX REPLACE "^\\.\\.\\/" "" DIR ${DIR})
        INSTALL(FILES ${HEADER} DESTINATION ${DIR})
    ENDFOREACH(HEADER)
ENDMACRO()

INSTALL_HEADERS_WITH_DIRECTORY(${HEADERS})

=== tests/src/CMakeLists.txt ===
# Use libtins' include directories + test include directories
INCLUDE_DIRECTORIES(
    ${PROJECT_SOURCE_DIR}/include/
    ../include/
    ${GOOGLETEST_INCLUDE}
    ${PCAP_INCLUDE_DIR}
)

# Find pthread library
FIND_PACKAGE(Threads REQUIRED)

LINK_DIRECTORIES(
    ${GOOGLETEST_LIBRARY}
)
# Link against GoogleTest, libtins and pthread.
# Pthread is required by GoogleTest
LINK_LIBRARIES(
    gtest
    gtest_main
    tins 
    ${CMAKE_THREAD_LIBS_INIT}
    ${PCAP_LIBRARY}
)

ADD_CUSTOM_TARGET(tests)

MACRO(CREATE_TEST test_name)
    STRING(REPLACE "/" "_" binary_name ${test_name})
    SET(binary_name "${binary_name}_test")
    ADD_EXECUTABLE(${binary_name} EXCLUDE_FROM_ALL "${test_name}_test.cpp")
    ADD_TEST(${test_name} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${binary_name})
    ADD_DEPENDENCIES(tests ${binary_name})
ENDMACRO()

# Tests

CREATE_TEST(address_range)
CREATE_TEST(allocators)
CREATE_TEST(arp)
CREATE_TEST(dhcp)
CREATE_TEST(dhcpv6)
CREATE_TEST(dns)
CREATE_TEST(dot1q)
CREATE_TEST(ethernet)
CREATE_TEST(hw_address)
CREATE_TEST(icmp_extension)
CREATE_TEST(icmp)
CREATE_TEST(icmpv6)
CREATE_TEST(ip)
CREATE_TEST(ip_reassembler)
CREATE_TEST(ip_address)
CREATE_TEST(ipsec)
CREATE_TEST(ipv6)
CREATE_TEST(ipv6_address)
CREATE_TEST(llc)
CREATE_TEST(loopback)
CREATE_TEST(matches_response)
CREATE_TEST(mpls)
CREATE_TEST(network_interface)
CREATE_TEST(pdu)
CREATE_TEST(pdu_iterator)
CREATE_TEST(pppoe)
CREATE_TEST(raw_pdu)
CREATE_TEST(rc4_eapol)
CREATE_TEST(rsn_eapol)
CREATE_TEST(sll)
CREATE_TEST(snap)
CREATE_TEST(stp)
CREATE_TEST(tcp)
CREATE_TEST(tcp_ip)
CREATE_TEST(udp)
CREATE_TEST(utils)

IF(LIBTINS_ENABLE_PCAP)
    CREATE_TEST(offline_packet_filter)
    CREATE_TEST(tcp_stream)

    IF(LIBTINS_ENABLE_DOT11)
        CREATE_TEST(ppi)
    ENDIF()
ENDIF()

IF(LIBTINS_ENABLE_DOT11)
    CREATE_TEST(dot11/ack)
    CREATE_TEST(dot11/assoc_request)
    CREATE_TEST(dot11/assoc_response)
    CREATE_TEST(dot11/authentication)
    CREATE_TEST(dot11/beacon)
    CREATE_TEST(dot11/block_ack_request)
    CREATE_TEST(dot11/cf_end)
    CREATE_TEST(dot11/cf_end_ack)
    CREATE_TEST(dot11/data)
    CREATE_TEST(dot11/deauthentication)
    CREATE_TEST(dot11/disassoc)
    CREATE_TEST(dot11/dot11)
    CREATE_TEST(dot11/probe_request)
    CREATE_TEST(dot11/probe_response)
    CREATE_TEST(dot11/ps_poll)
    CREATE_TEST(dot11/reassoc_request)
    CREATE_TEST(dot11/reassoc_response)
    CREATE_TEST(dot11/rts)
    CREATE_TEST(radiotap)
    CREATE_TEST(wep_decrypt)
    IF(LIBTINS_ENABLE_WPA2)
        CREATE_TEST(wpa2_decrypt)
    ENDIF()
ENDIF()

=== tests/active_tests/src/CMakeLists.txt ===
FILE(GLOB SOURCES "*.cpp")

INCLUDE_DIRECTORIES(
    ${PROJECT_SOURCE_DIR}/include/
    ${PCAP_INCLUDE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
)

# Find pthread library
FIND_PACKAGE(Threads REQUIRED)

# Link against GoogleTest, libtins and pthread.
LINK_LIBRARIES(
    tins 
    ${CMAKE_THREAD_LIBS_INIT}
    ${PCAP_LIBRARY}
)

ADD_EXECUTABLE(active_tester EXCLUDE_FROM_ALL ${SOURCES})

=== debian/changelog ===
libtins (4.0-1build2) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 17:59:52 +0100

libtins (4.0-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:33 +0100

libtins (4.0-1) unstable; urgency=medium

  * New upstream release (Closes: #897440)
  * Add dependency (Closes: #894343)

 -- Federico Ceratto <federico@debian.org>  Wed, 19 Sep 2018 22:31:41 +0100

=== debian/control ===
Source: libtins
Priority: optional
Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
Uploaders: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper (>=11~),
 cmake,
 libpcap-dev,
 libssl-dev
Standards-Version: 4.2.1
Section: libs
Homepage: https://libtins.github.io/
Vcs-Git: https://salsa.debian.org/debian/libtins.git
Vcs-Browser: https://salsa.debian.org/debian/libtins

Package: libtins4.0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: packet crafting and sniffing library
 libtins is a high-level, multiplatform C++ network packet sniffing and
 crafting library.
 Its main purpose is to provide the C++ developer an easy, efficient, platform
 and endianess-independent way to create tools which need to send, receive and
 manipulate network packets.

Package: libtins-dev
Section: libdevel
Architecture: any
Depends: libtins4.0 (= ${binary:Version}), ${misc:Depends}, libpcap-dev
Description: packet crafting and sniffing library - development files
 libtins is a high-level, multiplatform C++ network packet sniffing and
 crafting library.
 Its main purpose is to provide the C++ developer an easy, efficient, platform
 and endianess-independent way to create tools which need to send, receive and
 manipulate network packets.
 This package contains development files.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export V=1  # verbose mode for make
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,--no-undefined,--no-add-needed
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_build:
	mkdir -p build
	cd build && cmake ../ -DLIBTINS_ENABLE_CXX11=1
	cd build && make

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

override_dh_auto_clean:
	rm build -rf
	dh_auto_clean

## libtins 4.5

=== debian/changelog ===
libtins (4.5-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 19:47:29 +0000

libtins (4.5-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:29:00 +0000

libtins (4.5-1) unstable; urgency=medium

  * New upstream release (Closes: #1050161)
  * Add multiarch support (Closes: #1024945)
    Kudos to Helmut Grohne

 -- Federico Ceratto <federico@debian.org>  Thu, 15 Feb 2024 17:26:17 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libtins
 Priority: optional
-Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Internet Measurement Packaging Team <pkg-netmeasure-discuss@lists.alioth.debian.org>
 Uploaders: Federico Ceratto <federico@debian.org>
-Build-Depends: debhelper (>=11~),
+Build-Depends: debhelper-compat (= 13),
  cmake,
  libpcap-dev,
  libssl-dev
@@ -12,7 +13,7 @@
 Vcs-Git: https://salsa.debian.org/debian/libtins.git
 Vcs-Browser: https://salsa.debian.org/debian/libtins
 
-Package: libtins4.0
+Package: libtins4.5
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: packet crafting and sniffing library
@@ -25,7 +26,7 @@
 Package: libtins-dev
 Section: libdevel
 Architecture: any
-Depends: libtins4.0 (= ${binary:Version}), ${misc:Depends}, libpcap-dev
+Depends: libtins4.5 (= ${binary:Version}), ${misc:Depends}, libpcap-dev
 Description: packet crafting and sniffing library - development files
  libtins is a high-level, multiplatform C++ network packet sniffing and
  crafting library.
@@ -33,4 +34,3 @@
  and endianess-independent way to create tools which need to send, receive and
  manipulate network packets.
  This package contains development files.
-

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libtins3-$1\.tar\.gz/ https://github.com/mfontanini/libtins/tags .*/v?(\d\S*)\.tar\.gz
